/*
    Close Children Comp
        あかつきみさき

    このスクリプトについて
        アクティブなコンポジションの下位コンポをすべて閉じるスクリプト.

    使用方法
        ファイル→スクリプト→スクリプトファイルを実行.

    動作環境
        Adobe After Effects CS6以上

    バージョン情報
        2018/06/17 Ver 1.0.0 Release
*/

/// <reference path="C:\Users\RUI\OneDrive\lib\aftereffects.d.ts\ae.d.ts"/>

(function () {
    let addedIds = [];
    let existsId = false;

    CompItem.prototype.closeChildrenComp = function () {
        alert(this.name);

        for (let i = 1; i <= this.layers.length; i++) {
            if (this.layer(i).source == null || !(this.layer(i).source instanceof CompItem)) {
                continue;
            }

            for (let j = 0; j < addedIds.length; j++) {
                if (addedIds[j] == this.layer(i).source.id) {
                    existsId = true;
                    break;
                }
            }

            if (existsId) {
                existsId = false;
                continue;
            }

            addedIds[addedIds.length] = this.layer(i).source.id;

            this.layer(i).source.closeChildrenComp();
            // ビューワーで開く
            this.layer(i).source.openInViewer();
            // タイムラインパネルにフォーカス
            app.executeCommand(app.findMenuCommandId("タイムライン: " + this.layer(i).source.name));
            // タイムラインパネルを閉じる
            app.executeCommand(app.findMenuCommandId("タイムライン: " + this.layer(i).source.name));
        }
    }

    let actComp = app.project.activeItem;
    if (actComp == null && !(actComp instanceof CompItem)) {
        return 0;
    }

    addedIds[addedIds.length] = actComp.id;
    actComp.closeChildrenComp();

    return 0;
}).call(this);
